/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Check for NULL pointer assignments                                     *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 *  Thanks go to Peter Fitzsimmons for this module.                        *
 *                                                                         *
 ***************************************************************************/


#include "prog.h"

/* don't do this in OS/2 with FAR data. OS/2 itself will find null pointers
 * for us.
 */
#if !(defined(OS_2) && ((defined(M_I86CM) || defined(M_I86LM) || defined(M_I86HM) || defined(__TURBOC__))))

/*PLF
 *
 * This version will work on any MSDOS compiler, in any model. It calculates
 * the null pointer checksum the first time it is called, then uses that
 * value as a sentinel thereafter.
 */

#define CHECK_SIZE 20    /* check-sum this many bytes */

int nullptr(void)
{
  static int checksum=0,
             FirstTime=TRUE; /* the valid chksum could be zero, so we need this */

  int oursum=0;

  char *null=NULL;

  int i;

  if (FirstTime)
  {
    FirstTime=FALSE;

    for(i=0;i < CHECK_SIZE;i++)
      checksum += null[i];

    return FALSE;
  }
  else
  {
    for (i=0;i < CHECK_SIZE;i++)
      oursum += null[i];

    return (oursum != checksum);
  }
}

#else
int nullptr(void)
{
    return(FALSE);
}
#endif

